# coding: utf-8

"""
    Coinbase Platform API

    This is the OpenAPI 3.0 specification for the Coinbase Platform APIs, used in conjunction with the Coinbase Platform SDKs.

    The version of the OpenAPI document: 0.0.1-alpha
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CompiledSmartContract(BaseModel):
    """
    Represents a compiled smart contract that can be deployed onchain
    """ # noqa: E501
    compiled_smart_contract_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the compiled smart contract.")
    solidity_input_json: Optional[StrictStr] = Field(default=None, description="The JSON-encoded input for the Solidity compiler")
    contract_creation_bytecode: Optional[StrictStr] = Field(default=None, description="The contract creation bytecode which will be used with constructor arguments to deploy the contract")
    abi: Optional[StrictStr] = Field(default=None, description="The JSON-encoded ABI of the contract")
    contract_name: Optional[StrictStr] = Field(default=None, description="The name of the smart contract to deploy")
    __properties: ClassVar[List[str]] = ["compiled_smart_contract_id", "solidity_input_json", "contract_creation_bytecode", "abi", "contract_name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CompiledSmartContract from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CompiledSmartContract from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "compiled_smart_contract_id": obj.get("compiled_smart_contract_id"),
            "solidity_input_json": obj.get("solidity_input_json"),
            "contract_creation_bytecode": obj.get("contract_creation_bytecode"),
            "abi": obj.get("abi"),
            "contract_name": obj.get("contract_name")
        })
        return _obj


