# coding: utf-8

"""
    Coinbase Platform API

    This is the OpenAPI 3.0 specification for the Coinbase Platform APIs, used in conjunction with the Coinbase Platform SDKs.

    The version of the OpenAPI document: 0.0.1-alpha
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List
from cdp.client.models.crypto_amount import CryptoAmount
from cdp.client.models.fiat_amount import FiatAmount
from typing import Optional, Set
from typing_extensions import Self

class FundOperationFees(BaseModel):
    """
    The fees for a fund operation.
    """ # noqa: E501
    buy_fee: FiatAmount
    transfer_fee: CryptoAmount
    __properties: ClassVar[List[str]] = ["buy_fee", "transfer_fee"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FundOperationFees from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of buy_fee
        if self.buy_fee:
            _dict['buy_fee'] = self.buy_fee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transfer_fee
        if self.transfer_fee:
            _dict['transfer_fee'] = self.transfer_fee.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FundOperationFees from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "buy_fee": FiatAmount.from_dict(obj["buy_fee"]) if obj.get("buy_fee") is not None else None,
            "transfer_fee": CryptoAmount.from_dict(obj["transfer_fee"]) if obj.get("transfer_fee") is not None else None
        })
        return _obj


