# coding: utf-8

"""
    Coinbase Platform API

    This is the OpenAPI 3.0 specification for the Coinbase Platform APIs, used in conjunction with the Coinbase Platform SDKs.

    The version of the OpenAPI document: 0.0.1-alpha
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from cdp.client.models.transaction_type import TransactionType
from typing import Optional, Set
from typing_extensions import Self

class SignatureCreationEvent(BaseModel):
    """
    An event representing a signature creation.
    """ # noqa: E501
    seed_id: StrictStr = Field(description="The ID of the seed that the server-signer should create the signature for")
    wallet_id: StrictStr = Field(description="The ID of the wallet the signature is for")
    wallet_user_id: StrictStr = Field(description="The ID of the user that the wallet belongs to")
    address_id: StrictStr = Field(description="The ID of the address the transfer belongs to")
    address_index: StrictInt = Field(description="The index of the address that the server-signer should sign with")
    signing_payload: StrictStr = Field(description="The payload that the server-signer should sign")
    transaction_type: TransactionType
    transaction_id: StrictStr = Field(description="The ID of the transaction that the server-signer should sign")
    __properties: ClassVar[List[str]] = ["seed_id", "wallet_id", "wallet_user_id", "address_id", "address_index", "signing_payload", "transaction_type", "transaction_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignatureCreationEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignatureCreationEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "seed_id": obj.get("seed_id"),
            "wallet_id": obj.get("wallet_id"),
            "wallet_user_id": obj.get("wallet_user_id"),
            "address_id": obj.get("address_id"),
            "address_index": obj.get("address_index"),
            "signing_payload": obj.get("signing_payload"),
            "transaction_type": obj.get("transaction_type"),
            "transaction_id": obj.get("transaction_id")
        })
        return _obj


